///
/// HybridMathSpecSwift.hpp
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2025 Marc Rousavy @ Margelo
///

#pragma once

#include "HybridMathSpec.hpp"

// Forward declaration of `HybridMathSpec_cxx` to properly resolve imports.
namespace NitroMath { class HybridMathSpec_cxx; }





#include "NitroMath-Swift-Cxx-Umbrella.hpp"

namespace margelo::nitro::math {

  /**
   * The C++ part of HybridMathSpec_cxx.swift.
   *
   * HybridMathSpecSwift (C++) accesses HybridMathSpec_cxx (Swift), and might
   * contain some additional bridging code for C++ <> Swift interop.
   *
   * Since this obviously introduces an overhead, I hope at some point in
   * the future, HybridMathSpec_cxx can directly inherit from the C++ class HybridMathSpec
   * to simplify the whole structure and memory management.
   */
  class HybridMathSpecSwift: public virtual HybridMathSpec {
  public:
    // Constructor from a Swift instance
    explicit HybridMathSpecSwift(const NitroMath::HybridMathSpec_cxx& swiftPart):
      HybridObject(HybridMathSpec::TAG),
      _swiftPart(swiftPart) { }

  public:
    // Get the Swift part
    inline NitroMath::HybridMathSpec_cxx getSwiftPart() noexcept { return _swiftPart; }

  public:
    // Get memory pressure
    inline size_t getExternalMemorySize() noexcept override {
      return _swiftPart.getMemorySize();
    }

  public:
    // Properties
    inline double getPi() noexcept override {
      return _swiftPart.getPi();
    }

  public:
    // Methods
    inline double add(double a, double b) override {
      auto __result = _swiftPart.add(std::forward<decltype(a)>(a), std::forward<decltype(b)>(b));
      if (__result.hasError()) [[unlikely]] {
        std::rethrow_exception(__result.error());
      }
      auto __value = std::move(__result.value());
      return __value;
    }

  private:
    NitroMath::HybridMathSpec_cxx _swiftPart;
  };

} // namespace margelo::nitro::math
